"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var headphone_list_1 = __importDefault(require("../headphone_list"));
var FilterKnownHeadphones = /** @class */ (function () {
    function FilterKnownHeadphones() {
    }
    FilterKnownHeadphones.prototype.execute = function (rawHeadphones) {
        return rawHeadphones.reduce(function (knownHeadphones, rawHeadphone) {
            headphone_list_1.default.filter(function (known) {
                if (known.vendorId === rawHeadphone.vendorId &&
                    known.productId === rawHeadphone.productId) {
                    known.path = rawHeadphone.path;
                    knownHeadphones.push(known);
                    return knownHeadphones;
                }
                if (rawHeadphone.path === undefined) {
                    return knownHeadphones;
                }
                var regex = new RegExp("(Steel\\s*?Series\\s*?".concat(known.name, "\\@)|(").concat(known.name, ")\\@"), 'i');
                if (regex.test(rawHeadphone.path)) {
                    known.path = rawHeadphone.path;
                    knownHeadphones.push(known);
                }
            });
            return knownHeadphones;
        }, []);
    };
    return FilterKnownHeadphones;
}());
exports.default = FilterKnownHeadphones;
