"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var headphone_list_1 = __importDefault(require("../headphone_list"));
var FindHeadphones = /** @class */ (function () {
    function FindHeadphones(gateway) {
        this.gateway = gateway;
    }
    FindHeadphones.prototype.execute = function () {
        var devices = this.gateway.getUsbDevices();
        return devices.reduce(function (matchedHeadphones, device) {
            var matched = headphone_list_1.default.find(function (knownHeadphone) {
                return (knownHeadphone.vendorId === device.vendorId &&
                    knownHeadphone.productId === device.productId);
            });
            if (matched) {
                matchedHeadphones.push({
                    device: device,
                    knownHeadphone: matched,
                });
            }
            return matchedHeadphones;
        }, []);
    };
    return FindHeadphones;
}());
exports.default = FindHeadphones;
