"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var Arctis7xBuilder = /** @class */ (function () {
    function Arctis7xBuilder() {
    }
    Arctis7xBuilder.prototype.execute = function (report, knownHeadphone) {
        var isMuted, isCharging, isDischarging, isConnected;
        if (knownHeadphone.micStatusIdx) {
            isMuted = report[knownHeadphone.micStatusIdx] === 1;
        }
        if (knownHeadphone.chargingStatusIdx) {
            switch (report[knownHeadphone.chargingStatusIdx]) {
                case 0: // Not Connected
                    isConnected = false;
                    isCharging = undefined;
                    isDischarging = undefined;
                    break;
                case 1: // Charging
                    isConnected = true;
                    isCharging = true;
                    isDischarging = false;
                    break;
                case 3: // Discharging
                    isConnected = true;
                    isCharging = false;
                    isDischarging = true;
                    break;
            }
        }
        return { isMuted: isMuted, isCharging: isCharging, isDischarging: isDischarging, isConnected: isConnected };
    };
    return Arctis7xBuilder;
}());
exports.default = Arctis7xBuilder;
