"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var builder_1 = __importDefault(require("./headsets/builder"));
var RefreshInfo = /** @class */ (function () {
    function RefreshInfo(gateway, filterUseCase) {
        this.gateway = gateway;
        this.filterUseCase = filterUseCase;
    }
    RefreshInfo.prototype.execute = function (rawHeadphones) {
        var knownHeadphones = this.filterUseCase.execute(rawHeadphones);
        return this.refresh(knownHeadphones);
    };
    RefreshInfo.prototype.refresh = function (knownHeadphones) {
        var _this = this;
        return knownHeadphones.reduce(function (refreshed, known) {
            var headphone = _this.gateway.getHeadphoneByVendorIdAndProductId(known.vendorId, known.productId);
            if (Object.keys(headphone).length === 0 && headphone.constructor === Object) {
                return refreshed;
            }
            var report = headphone.fetchInfo(known.writeBytes);
            if (report.length > 0) {
                refreshed.push(builder_1.default.build(report, known.path, known));
            }
            return refreshed;
        }, []);
    };
    return RefreshInfo;
}());
exports.default = RefreshInfo;
